%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Program ilustrujcy rozwijanie sygnaw w wykladniczy szereg Fouriera
% v. 28.11.2018
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Program przedstawia syntez trzech sygnaw okresowych ze skadowych
% harmonicznych.
% Uytkownik moe wybra rodzaj sygnau prostokt, trjkt rwnoramienny 
% lub pia. W przypadku sygnau prostoktnego moliwa jest zmiana
% wypenienia za pomoc wspczynnika alfa.
% Moliwa jest zmiana nastpujcych parametrw:
% - numer najwyszej harmonicznej - kmax
% - przesuniecie sygnau w czasie - t0
% - czas obserwacji sygnau - Tmax
% Mona te dokona zmiany fazy wybranych wspczynnikw rozwinicia,
% naley jednak uwaa, aby nie przekroczy maksymalnego numeru
% harmonicznej - modyfikacje dla wyszych skadowych zostan zignorowane
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Czyszczenie wszystkiego
close all;
clear;
clc;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Stae potrzebne w programie
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Wybierz posta sygnau
%   1 - prostokt,
%   2 - trjkt,
%   3 - pia
postac_s=3;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Ustaw ilo sumowanych sygnaw skadowych
% numer najwyszej harmonicznej
kmax=3;
% ilo skadowych harmonicznych
ile_k=2*kmax+1;
% amplituda sygnau
A=1;
% okres sygnau
T=1;
% przesunicie sygnau w czasie (0 - 1)
t0=-0.0;
% pulsacja podstawowa
w0=2*pi/T;
% okres prbkowania skadowych (i sygnau wypadkowego)
dt=0.0001;
% czas obserwacji sygnau
Tmax=3;
% wektor numerw harmonicznych od -kmax do kmax
k=[-kmax:-1 0 1:kmax];
% przecznik wywietlania wykresw trjwymiarowych
WYKRESY_3D=0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% modyfikacje widma fazowego
% wektor wspczynnikw modyfikujcych widmo fazowe
mfi=ones(size(k));
% czy wczy modyfikacje fazy? 1 - tak, 0 - nie
MODF=0;
if(MODF)
    disp('Wczono modyfikacj widma fazowego! Posta sygnau bdzie zmieniona!');
    % numer modyfikowanej skadowej - moe si zmienia od -kmax do +kmax
    nrmodf=1;
    if((nrmodf>(-kmax+1))&&(nrmodf>(-kmax+1)))
        % zmiana fazy modyfikowanej skadowej
        mfi(kmax+1+nrmodf)=exp(-1i*pi/4);
        if(angle(mfi(kmax+1+nrmodf))~=0)
            disp(['Zmieniono faz ' num2str(nrmodf) ' skadowej harmonicznej o fi=' num2str(angle(mfi(kmax+1+nrmodf))) '[rad].']);
        end;    % koniec dla if(angle(mfi(kmax+1+nrmodf))~=0)
    end;    % koniec dla if((nrmodf>(-kmax+1))&&(nrmodf>(-kmax+1)))
    nrmodf=-11;
    if((nrmodf>(-kmax+1))&&(nrmodf>(-kmax+1)))
        % zmiana fazy modyfikowanej skadowej
        mfi(kmax+1+nrmodf)=exp(0*-1i*pi/9);
        if(angle(mfi(kmax+1+nrmodf))~=0)
            disp(['Zmieniono faz ' num2str(nrmodf) ' skadowej harmonicznej o fi=' num2str(angle(mfi(kmax+1+nrmodf))) '[rad].']);
        end;    % koniec dla if(angle(mfi(kmax+1+nrmodf))~=0)
    end;    % koniec dla if((nrmodf>(-kmax+1))&&(nrmodf>(-kmax+1)))
    nrmodf=-1;
    if((nrmodf>(-kmax+1))&&(nrmodf>(-kmax+1)))
        % zmiana fazy modyfikowanej skadowej
        mfi(kmax+1+nrmodf)=exp(0*-1i*pi/3);
        if(angle(mfi(kmax+1+nrmodf))~=0)
            disp(['Zmieniono faz ' num2str(nrmodf) ' skadowej harmonicznej o fi=' num2str(angle(mfi(kmax+1+nrmodf))) '[rad].']);
        end;    % koniec dla if(angle(mfi(kmax+1+nrmodf))~=0)
    end;    % koniec dla if((nrmodf>(-kmax+1))&&(nrmodf>(-kmax+1)))
    % tutaj mona skopiowa jedn z powyszych sekcji if ... end
    % i doda wicej modyfikacji dla innych skadowych harmonicznych
end;    % koniec dla if(MODF)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% utworzenie cigu wspczynnikw
% dla wybranej postaci sygnau
switch postac_s
   case 1
        % sygna
        % prostoktny o wypenieniu alfa
        alfa=0.3;
        disp(['Sygna prostoktny o wypenieniu ' num2str(alfa*100) ' %']);
        % wspczynniki od a(-kmax) do a(-1) i od a1 do a(kmax)
        ak=sin(alfa*k*pi)./(alfa*k*pi);
%         ak=(exp(-1i*k*pi)-1)./(-1i*k*pi);
        % wspczynnik a0 - skadowa staa
        ak(kmax+1)=0;
        % fazy skadowych harmonicznych
        fi=exp(1i*k*w0*t0).*mfi;
        % modyfikujemy wspczynniki ak za pomoc faz
        ak=ak.*fi;
   case 2
        % sygna
        % trjktny symetryczny
        disp('Sygna trjktny symetryczny');
        % wspczynniki od a(-kmax) do a(-1) i od a1 do a(kmax)
        ak=A*(cos(k*pi)-1)./((k.^2));
        % wspczynnik a0 - skadowa staa
        ak(kmax+1)=0;
        % fazy skadowych harmonicznych
        fi=exp(1i*k*w0*t0).*mfi;
        % modyfikujemy wspczynniki ak za pomoc faz
        ak=ak.*fi;
   case 3
        % sygna trjktny asymetryczny
        disp('Sygna trjktny asymetryczny');
        % wspczynniki od a(-kmax) do a(-1) i od a1 do a(kmax)
        ak=(1i*A./(2*k*pi));
        % wspczynnik a0 - skadowa staa
        ak(kmax+1)=A/2;    
        % fazy skadowych harmonicznych
        fi=exp(1i*k*w0*t0).*mfi;
        % modyfikujemy wspczynniki ak za pomoc faz
        ak=ak.*fi;
end     % koniec dla switch postac_s
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% wykrelenie widma amplitudowego
figure;
bar(k,abs(ak),0.1,'EdgeColor',[0 0 0]);
% i fazowego
figure;
bar(k,angle(ak),0.1,'EdgeColor',[0 0 0]);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% aproksymacja sygnau na podstawie szeregu Fouriera
% wektor czasu dla sygnau
t=0:dt:Tmax;
% definiujemy tablic sygnaow o takim samym rozmiarze co wektor czasu
sygnal=zeros(size(t));
% definiujemy tablic funkcji bazowych
fbaz=zeros(ile_k,size(t,2));
% oraz tablic skadowych harmonicznych, czyli funkcji bazowych o
% odpowiednich amplitudach
fbaz_w=zeros(ile_k,size(t,2));
% generujemy funkcje bazowe
fbaz=exp(1i*k'*w0*t);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% odtwarzamy sygna ze skadowych harmonicznych
for nrharm=1:ile_k
    % sumujemy kolejne funkcje bazowe pomnoone przez wspczynniki
    fbaz_w(nrharm,:)=ak(nrharm)*fbaz(nrharm,:);
	sygnal=sygnal+fbaz_w(nrharm,:);
end;    % for nrharm=1:ile_k
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% rysujemy skadowe harmoniczne sygnau
figure;
plot(t,real(fbaz_w'),'LineWidth',1);
% i sam sygna
figure;
plot(real(sygnal));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if(WYKRESY_3D)
    % trjwymiarowy wykres pierwszej harmonicznej
    si=zeros(size(t));
    figure;
    plot3(t,si,real(fbaz_w(kmax+2,:)),'b','LineWidth',1);
    hold on;
    plot3(t,imag(fbaz_w(kmax+2,:)),si,'r','LineWidth',1);
    plot3(t,imag(fbaz_w(kmax+2,:)),real(fbaz_w(kmax+2,:)),'k','LineWidth',1);
    grid on;
    box on;
    % trjwymiarowy wykres wszystkich harmonicznych
    % zerujemy skadow sta
    fbaz_w(kmax+1,:)=0;
    figure;
    plot3(t,si,real(fbaz_w((kmax+2:end),:))','LineWidth',1);
    hold on;
    plot3(t,imag(fbaz_w((kmax+2:end),:))',si,'LineWidth',1);
    grid on;
    box on;
end;    % koniec dla if(WYKRESY_3D)